/* Copyright 2010 Santiago Ontanon and Ashwin Ram */

package d2.execution.adaptation;

import d2.core.D2;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.jdom.Element;

import d2.execution.planbase.PlanBase;
import d2.plans.Plan;

import gatech.mmpm.GameState;

import gatech.mmpm.sensor.Sensor;
import gatech.mmpm.util.XMLWriter;
import java.util.List;

public abstract class PlanAdaptation {

        protected D2 m_d2 = null;
	protected String currentPlayer = null;
	
	public abstract Plan adapt(Plan original_plan,GameState original_gs, String original_player, Sensor original_goal,
							   int current_cycle, GameState current_gs, String current_player, Sensor current_goal,
                               List<String> usedIDs);
	
	public abstract void adaptToAllow(Plan original_plan, GameState original_gs, String original_player,
                                      Plan planToAllow, int current_cycle, GameState current_gs, String current_player,
                                      PlanBase pb, PlanAdaptation parameterAdapter,List<String> usedIDs);
	
	public PlanAdaptation(String player)
	{
		currentPlayer = player;
	}
	
	public void setPlayer(String player) {
		currentPlayer = player;
	}

        public void setD2(D2 d2) {
            m_d2 = d2;
        }
	
	public abstract void saveToXML(XMLWriter w);

	public static PlanAdaptation loadFromXML(Element xml,String a_player) {
		Class<?> c;
		try {
			
			c = Class.forName(xml.getChildText("type"));
			Method m = c.getMethod("loadFromXMLInternal", new Class[]{Element.class,String.class});
			return (PlanAdaptation) m.invoke(c, xml,a_player);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;		
	}

	public static PlanAdaptation loadFromXMLInternal(Element xml,String a_player) {
		return null;
	}
	
}
