/* Copyright 2010 Santiago Ontanon and Ashwin Ram */

package d2.learn.planlearning;

import java.util.ArrayList;

public class ActionFilteredParameter {

	String actionName;
	String performingEntityType;
	ArrayList<String> actionParameters;
	public ActionFilteredParameter(String actionName_,String performingEntityType_)
	{
		actionName=actionName_;
		performingEntityType=performingEntityType_;
		actionParameters=new ArrayList<String>();
	}
	public void addActionParameter(String parameter_)
	{
		actionParameters.add(parameter_);
	}
	public String getActionName() {
		return actionName;
	}
	public void setActionName(String actionName) {
		this.actionName = actionName;
	}
	public String getPerformingEntityType() {
		return performingEntityType;
	}
	public void setPerformingEntityType(String performingEntityType) {
		this.performingEntityType = performingEntityType;
	}
	public ArrayList<String> getActionParameters() {
		return actionParameters;
	}
	public void setActionParameters(ArrayList<String> actionParameters) {
		this.actionParameters = actionParameters;
	}
    public String toString()
    {
    	String afpString=actionName+" "+performingEntityType;
    	for(String acParam : actionParameters)
    	afpString+=" "+acParam;
    	return afpString;
    }
	
    public boolean equals(ActionFilteredParameter afp)
    {
    	boolean flag=false;
    	if(afp == null|| this.actionParameters.size() != afp.actionParameters.size())
    		return flag;
    	if(this.actionName.equals(afp.actionName)&&this.performingEntityType.equals(afp.performingEntityType))
    	{
    		flag=true;
    		for(int index=0;index < actionParameters.size();index++)
    			if(!this.getActionParameters().get(index).equals(afp.getActionParameters().get(index)))
    			{
    				flag=false;
    				break;
    			}
    	}
    	return flag;
    	
    }
    
}
