/* Copyright 2010 Santiago Ontanon and Ashwin Ram */

package d2.learn.planlearning;

import d2.core.D2;
import java.util.List;

import d2.execution.planbase.PlanBase;

import gatech.mmpm.Trace;

public abstract class PlanLearning {
	
	protected D2 m_d2;

	protected String domainName;
	
	public PlanLearning(D2 d2, String domainName) {
		
		m_d2 = d2;
		this.domainName = domainName; 
	}

    public void setD2(D2 a_d2) {
        m_d2 = a_d2;
    }
	
	public abstract void learnFromTrace(Trace t,String playerName);
	
	public void learnFromTraces(List<String> trace_file_names,List<String> playerNames) {
		int count = 0;
		
		System.out.println("PlanLearning.learnFromTraces: " + trace_file_names.size() + " traces");

		for(count = 0;count<trace_file_names.size();count++) {
			String filename = trace_file_names.get(count);
			String playerName = playerNames.get(count);

			System.out.println("PlanLearning.learnFromTraces: " + filename + " -> " + playerName);

			Trace trace = gatech.mmpm.tracer.TraceParser.parse(filename, d2.core.Config.getDomain());
			if (trace != null) {
				trace.setTraceID(count);
				learnFromTrace(trace, playerName);
			} else {
				System.err.println("Failed to load trace in " + filename);
			}
		}
	}
	
}
