/* Copyright 2010 Santiago Ontanon and Ashwin Ram */

package d2.learn.planlearning.goalrec;

/**
 * @author kane
 *
 * Wrapper for GameTreeNode and GameStateDeltas between the given node and a node that depends on it.
 */
public class DependencyNode {
	/** the delta between this node and the next one. */
	private GameStateDelta delta;
	/** the GameTreeNode the next node depends on */
	private GameTreeNode depended;
	/** the node with the dependency */
	private GameTreeNode depending;
	
	/**
	 * Default constructor.
	 * @param d
	 * @param n
	 */
	public DependencyNode(GameStateDelta d, GameTreeNode n, GameTreeNode g) {
		delta = d;
		depended = n;
		depending = g;
	}
	
	/**
	 * @return the delta
	 */
	public GameStateDelta getDelta() {
		return delta;
	}

	/**
	 * @return the depended
	 */
	public GameTreeNode getDepended() {
		return depended;
	}

	/**
	 * @return the depending
	 */
	public GameTreeNode getDepending() {
		return depending;
	}
	
}
