/* Copyright 2010 Santiago Ontanon and Ashwin Ram */

package d2.worldmodel.domainspecific;

import gatech.mmpm.IDomain;
import gatech.mmpm.Trace;
import gatech.mmpm.tracer.TraceParser;

import java.util.LinkedList;
import java.util.List;

import d2.worldmodel.WorldModel;


/**
 * This file was in s2 but has been moved to this place because is D2 dependent.
 * Now it test the S2 world model but it can be easily changed to works with
 * the rest of the world models. 
 *
 * Moved by David Llanso.
 */
public class TestWM {
	public static void main(String args[]) throws Exception {
		String worldModelClassName = "s2.d2.S2Domain";
		Class worldModelClass = Class.forName(worldModelClassName);
		
		// Load the traces:
		List<String> files = new LinkedList<String>();
		files.add("traces/trace-NWTR-tower-ballistas-1.xml");
		List<Trace> traces = new LinkedList<Trace>();
		
		for(String fn:files) {
			traces.add(TraceParser.parse(fn, d2.core.Config.getDomain()));
		}

		// Learn the World model:
		d2.worldmodel.WorldModel wm = (WorldModel)(worldModelClass.newInstance());
		wm.learnFromTraces(files);
		System.out.println("World Model Learnt:");
		System.out.println(wm.toString());

		// Evaluate the learnt model:
		for (Trace t : traces)
			wm.evaluateWithTrace(t);

		// Run the first trace from state 0 and visualize the result of the
		// simulator:
		Trace t = traces.get(0);
		wm.getActionsModel().visualizeWithTrace(t);

	}

}
