package eisbot.proxy;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.LinkedList;
import java.util.List;

import d2.core.D2;
import d2.execution.adaptation.NothingPlanAdaptation;
import d2.execution.adaptation.parameters.SystematicParameterAdaptation;
import d2.execution.planbase.PlanBase;
import d2.execution.planbase.SimilarityRetrieval;
import d2.execution.planexecution.RealTimePlanExecution;
import d2.execution.planner.SimpleExpandPlanner;
import d2.worldmodel.WorldModel;

import eisbot.proxy.starmok.BroodWarDomain;
import eisbot.proxy.starmok.Game2D2Converter;
import eisbot.proxy.starmok.StarmokTracer;
import gatech.mmpm.ConfigurationException;
import gatech.mmpm.learningengine.MEExecutorFactory;
public class D2AIClient implements BWAPIEventListener {

	private JNIBWAPI bwapi;
	private StarmokTracer tracer;
	private gatech.mmpm.learningengine.IMEExecutor D2AI;
	List<gatech.mmpm.Action> d2Actions = new LinkedList<gatech.mmpm.Action>();
	
	public static void main(String[] args) {
		/**/try {
			PrintStream log = new PrintStream("log.txt");
			System.setOut(log);
			System.setErr(log);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}/**/
		new D2AIClient();
	}
	
	public D2AIClient() {
		BwapiSingleton.initBWAPI(this);
		bwapi = BwapiSingleton.getBWAPI();
		bwapi.start();
	}

	public void connected() {
		bwapi.loadTypeData();
	}
	
	public void gameStarted() {
		bwapi.enableUserInput();
		//bwapi.enablePerfectInformation();
		bwapi.loadMapData(true);
		tracer = new StarmokTracer(25, 0);
		tracer.startTrace();
		try {
			D2AI = MEExecutorFactory.BuildMEExecutor("d2.core.D2@@@zipfile@@@myme.zip",tracer.getDomain()); // @@@gatech.mmpm.learningengine.ThreadedMEExecutor
            //PlanBase pb = new SimilarityRetrieval(null);
            //pb.addPlans("pb.xml");
            //d2.core.Config.setDomain(tracer.getDomain());
            /*D2AI = new D2("pb.xml", new SimpleExpandPlanner(), new RealTimePlanExecution(),
                    new NothingPlanAdaptation(null),
                    new SystematicParameterAdaptation("player"+bwapi.getSelf().getID(), 5),
                    new WorldModel());*/
			//D2AI = MEExecutorFactory.BuildMEExecutor("d2.core.D2@@@file@@@me.xml",tracer.getDomain());
		} catch (ConfigurationException e) {
			e.printStackTrace();
		}
		if(D2AI != null) {
			/**/d2.execution.adaptation.parameters.ParameterAdaptation.DEBUG = 2;
			d2.execution.adaptation.parameters.ParameterAdaptation.DEBUG_COORDINATES = 1;
			d2.execution.adaptation.parameters.ParameterAdaptation.DEBUG_ENTITIES = 2;
			((D2)D2AI).DEBUG = 1;/**/
			d2.execution.planexecution.PlanExecution.DEBUG = 2;//0;
			d2.execution.planexecution.PlanExecution.EXECUTION_DEBUG = 2;//0;
			d2.execution.planner.Planner.DEBUG = 2;
			D2AI.gameStart("player"+bwapi.getSelf().getID());
		} else {
			System.out.println("ME Executor does not exist!");
		}
	}
	
	public void gameUpdate() 
	{
		tracer.doTrace();
		if (bwapi.getFrameCount() % 25 == 1)
		{
			d2Actions.clear();
			if(D2AI != null) {
				D2AI.getActions(tracer, d2Actions);
				if(!d2Actions.isEmpty()) System.out.println("Got " + d2Actions.size() + " actions!");
			}
			for (gatech.mmpm.Action a : d2Actions) {
				Game2D2Converter.toGameAction(a);
			}
		}
	}
	public void gameEnded() {}
	public void keyPressed(int keyCode) {}
	public void matchEnded(boolean winner) {
		tracer.endTrace(winner);
		if(D2AI != null) {
			D2AI.gameEnd();
		}
	}
	public void nukeDetect(int x, int y) { }
	public void nukeDetect() { }
	public void playerLeft(int id) { }
	public void unitCreate(int unitID) { }
	public void unitDestroy(int unitID) { }
	public void unitDiscover(int unitID) { }
	public void unitEvade(int unitID) { }
	public void unitHide(int unitID) { }
	public void unitMorph(int unitID) { }
	public void unitShow(int unitID) { }
}
