package eisbot.proxy;
import eisbot.proxy.starmok.StarmokTracer;
public class TracerClient implements BWAPIEventListener {

	private JNIBWAPI bwapi;
	private StarmokTracer tracer;
	
	public static void main(String[] args) {
		new TracerClient();
	}
	
	public TracerClient() {
		BwapiSingleton.initBWAPI(this);
		bwapi = BwapiSingleton.getBWAPI();
		bwapi.start();
	}

	public void connected() {
		bwapi.loadTypeData();
	}
	public void gameStarted() {
		bwapi.enableUserInput();
		bwapi.loadMapData(true);
		tracer = new StarmokTracer(25, -1);
		tracer.startTrace();
	}
	public void gameUpdate() 
	{
		tracer.doTrace();
	}
	public void gameEnded() {}
	public void keyPressed(int keyCode) {}
	public void matchEnded(boolean winner) {
		tracer.endTrace(winner);
	}
	public void nukeDetect(int x, int y) { }
	public void nukeDetect() { }
	public void playerLeft(int id) { }
	public void unitCreate(int unitID) { }
	public void unitDestroy(int unitID) { }
	public void unitDiscover(int unitID) { }
	public void unitEvade(int unitID) { }
	public void unitHide(int unitID) { }
	public void unitMorph(int unitID) { }
	public void unitShow(int unitID) { }
}
