/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.entities;

import gatech.mmpm.Action;


import java.util.List;

/**
 * Class that represents a particular entity type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Entity for more information.
 */
public class Player extends gatech.mmpm.Entity {

	public Player(String entityID, String owner) {
	
		super(entityID, owner);
		_hasWon = 0;
		
	} // Constructor

	//---------------------------------------------------------------

	public Player(Player rhs) {

		super(rhs);
		_race = rhs._race;
		_minerals = rhs._minerals;
		_gas = rhs._gas;
		_supply = rhs._supply;
		_research = rhs._research;
		_upgrades = rhs._upgrades;
		_supply_total = rhs._supply_total;
		_hasWon = rhs._hasWon;

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		Player e = new Player(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	public char instanceShortName() {
	
		return '\0';
	
	} // instanceShortName

	//---------------------------------------------------------------
	
	public List<String> listOfFeatures() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfFeatures;

	} // listOfFeatures
	
	//---------------------------------------------------------------
	
	public List<gatech.mmpm.Action> listOfActions() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfActions;

	} // listOfActions

	//---------------------------------------------------------------

	public boolean isActive() {

		return false;

	} // isActive

	//---------------------------------------------------------------
	//                       Getter & setter
	//---------------------------------------------------------------


	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        race feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public String getRace() {

		return _race;

	} // getRace

	public void setRace(String rhs) {

		_race = rhs;

	} // setRace

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        minerals feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getMinerals() {

		return _minerals;

	} // getMinerals

	public void setMinerals(int rhs) {

		_minerals = rhs;

	} // setMinerals

	public void setMinerals(String rhs) {

		_minerals = Integer.parseInt(rhs);

	} // setMinerals(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        gas feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getGas() {

		return _gas;

	} // getGas

	public void setGas(int rhs) {

		_gas = rhs;

	} // setGas

	public void setGas(String rhs) {

		_gas = Integer.parseInt(rhs);

	} // setGas(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        supply feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getSupply() {

		return _supply;

	} // getSupply

	public void setSupply(int rhs) {

		_supply = rhs;

	} // setSupply

	public void setSupply(String rhs) {

		_supply = Integer.parseInt(rhs);

	} // setSupply(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        research feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public String getResearch() {

		return _research;

	} // getResearch

	public void setResearch(String rhs) {

		_research = rhs;

	} // setResearch

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        upgrades feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public String getUpgrades() {

		return _upgrades;

	} // getUpgrades

	public void setUpgrades(String rhs) {

		_upgrades = rhs;

	} // setUpgrades

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        supply_total feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getSupply_total() {

		return _supply_total;

	} // getSupply_total

	public void setSupply_total(int rhs) {

		_supply_total = rhs;

	} // setSupply_total

	public void setSupply_total(String rhs) {

		_supply_total = Integer.parseInt(rhs);

	} // setSupply_total(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        hasWon feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getHasWon() {

		return _hasWon;

	} // getHasWon

	public void setHasWon(int rhs) {

		_hasWon = rhs;

	} // setHasWon

	public void setHasWon(String rhs) {

		_hasWon = Integer.parseInt(rhs);

	} // setHasWon(String)


	//---------------------------------------------------------------
	//                 Generic getter and setter
	//---------------------------------------------------------------

	public Object featureValue(String feature) {

		if (feature.compareTo("race") == 0)
			return getRace();
		else 
		if (feature.compareTo("minerals") == 0)
			return getMinerals();
		else 
		if (feature.compareTo("gas") == 0)
			return getGas();
		else 
		if (feature.compareTo("supply") == 0)
			return getSupply();
		else 
		if (feature.compareTo("research") == 0)
			return getResearch();
		else 
		if (feature.compareTo("upgrades") == 0)
			return getUpgrades();
		else 
		if (feature.compareTo("supply_total") == 0)
			return getSupply_total();
		else 
		if (feature.compareTo("hasWon") == 0)
			return getHasWon();
		else 
			return super.featureValue(feature);
	
	} // featureValue

	//---------------------------------------------------------------

	public void setFeatureValue(String feature, String value) {

		if (feature.compareTo("race") == 0)
			setRace(value);
		else 
		if (feature.compareTo("minerals") == 0)
			setMinerals(value);
		else 
		if (feature.compareTo("gas") == 0)
			setGas(value);
		else 
		if (feature.compareTo("supply") == 0)
			setSupply(value);
		else 
		if (feature.compareTo("research") == 0)
			setResearch(value);
		else 
		if (feature.compareTo("upgrades") == 0)
			setUpgrades(value);
		else 
		if (feature.compareTo("supply_total") == 0)
			setSupply_total(value);
		else 
		if (feature.compareTo("hasWon") == 0)
			setHasWon(value);
		else 
			super.setFeatureValue(feature, value);
	
	} // setFeatureValue

	//---------------------------------------------------------------
	//                       Static methods
	//---------------------------------------------------------------
	
	public static char shortName() {

		return '\0';

	} // shortName

	//---------------------------------------------------------------

	public static List<String> staticListOfFeatures() {

		return _listOfFeatures;

	}

	//---------------------------------------------------------------

	public static List<gatech.mmpm.Action> staticListOfActions() {

		return _listOfActions;

	}

	//---------------------------------------------------------------
	//                       Protected fields
	//---------------------------------------------------------------
	
	protected String _race;

	protected int _minerals;

	protected int _gas;

	protected int _supply;

	protected String _research;

	protected String _upgrades;

	protected int _supply_total;

	protected int _hasWon;



	static java.util.List<String> _listOfFeatures;

	static java.util.List<Action> _listOfActions;

	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add features to _listOfFeatures.
		_listOfFeatures = new java.util.LinkedList<String>(gatech.mmpm.Entity.staticListOfFeatures());
		_listOfFeatures.add("race");
		_listOfFeatures.add("minerals");
		_listOfFeatures.add("gas");
		_listOfFeatures.add("supply");
		_listOfFeatures.add("research");
		_listOfFeatures.add("upgrades");
		_listOfFeatures.add("supply_total");
		_listOfFeatures.add("hasWon");

		// Add valid actions to _listOfActions.
		_listOfActions = new java.util.LinkedList<Action>(gatech.mmpm.Entity.staticListOfActions());

	} // static initializer

} // class Player

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

