/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.entities;

import gatech.mmpm.Action;
import eisbot.proxy.starmok.actions.AttackLocation;
import eisbot.proxy.starmok.actions.AttackUnit;
import eisbot.proxy.starmok.actions.Build;
import eisbot.proxy.starmok.actions.Gather;
import eisbot.proxy.starmok.actions.Move;
import eisbot.proxy.starmok.actions.Repair;
import eisbot.proxy.starmok.actions.Stop;


import java.util.List;

/**
 * Class that represents a particular entity type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Entity for more information.
 */
public class Terran_SCV extends Unit {

	public Terran_SCV(String entityID, String owner) {
	
		super(entityID, owner);
		_max_hitpoints = 60;
		_attack = 5;
		_armor = 0;
		_width = 1;
		_length = 1;
		_cost_minerals = 50;
		_cost_gas = 0;
		_cost_supply = 2;
		_build_time = 300;
		
	} // Constructor

	//---------------------------------------------------------------

	public Terran_SCV(Terran_SCV rhs) {

		super(rhs);

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		Terran_SCV e = new Terran_SCV(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	public char instanceShortName() {
	
		return '\0';
	
	} // instanceShortName

	//---------------------------------------------------------------
	
	public List<String> listOfFeatures() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfFeatures;

	} // listOfFeatures
	
	//---------------------------------------------------------------
	
	public List<gatech.mmpm.Action> listOfActions() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfActions;

	} // listOfActions

	//---------------------------------------------------------------

	public boolean isActive() {

		return true;

	} // isActive

	//---------------------------------------------------------------
	//                       Getter & setter
	//---------------------------------------------------------------



	//---------------------------------------------------------------
	//                 Generic getter and setter
	//---------------------------------------------------------------

	public Object featureValue(String feature) {

			return super.featureValue(feature);
	
	} // featureValue

	//---------------------------------------------------------------

	public void setFeatureValue(String feature, String value) {

			super.setFeatureValue(feature, value);
	
	} // setFeatureValue

	//---------------------------------------------------------------
	//                       Static methods
	//---------------------------------------------------------------
	
	public static char shortName() {

		return '\0';

	} // shortName

	//---------------------------------------------------------------

	public static List<String> staticListOfFeatures() {

		return _listOfFeatures;

	}

	//---------------------------------------------------------------

	public static List<gatech.mmpm.Action> staticListOfActions() {

		return _listOfActions;

	}

	//---------------------------------------------------------------
	//                       Protected fields
	//---------------------------------------------------------------
	


	static java.util.List<String> _listOfFeatures;

	static java.util.List<Action> _listOfActions;

	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add features to _listOfFeatures.
		_listOfFeatures = new java.util.LinkedList<String>(Unit.staticListOfFeatures());

		// Add valid actions to _listOfActions.
		_listOfActions = new java.util.LinkedList<Action>(Unit.staticListOfActions());
		Action a;
		a = new Move(null, null);
		_listOfActions.add(a);

		a = new AttackUnit(null, null);
		_listOfActions.add(a);

		a = new AttackLocation(null, null);
		_listOfActions.add(a);

		a = new Stop(null, null);
		_listOfActions.add(a);

		a = new Gather(null, null);
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Command_Center");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Supply_Depot");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Refinery");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Barracks");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Academy");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Factory");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Starport");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Science_Facility");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Command_Center");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Engineering_Bay");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Armory");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Missile_Turret");
		_listOfActions.add(a);

		a = new Build(null, null);
		a.setParameterValue("type", "Terran_Bunker");
		_listOfActions.add(a);

		a = new Repair(null, null);
		_listOfActions.add(a);


	} // static initializer

} // class Terran_SCV

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

