/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.entities;

import gatech.mmpm.Action;


import java.util.List;

/**
 * Class that represents a particular entity type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Entity for more information.
 */
public class Unit extends gatech.mmpm.PhysicalEntity {

	public Unit(String entityID, String owner) {
	
		super(entityID, owner);
		_idle = 1;
		
	} // Constructor

	//---------------------------------------------------------------

	public Unit(Unit rhs) {

		super(rhs);
		_max_hitpoints = rhs._max_hitpoints;
		_max_energy = rhs._max_energy;
		_current_hitpoints = rhs._current_hitpoints;
		_current_energy = rhs._current_energy;
		_cost_minerals = rhs._cost_minerals;
		_cost_gas = rhs._cost_gas;
		_cost_supply = rhs._cost_supply;
		_attack = rhs._attack;
		_armor = rhs._armor;
		_build_time = rhs._build_time;
		_idle = rhs._idle;

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		Unit e = new Unit(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	public char instanceShortName() {
	
		return '\0';
	
	} // instanceShortName

	//---------------------------------------------------------------
	
	public List<String> listOfFeatures() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfFeatures;

	} // listOfFeatures
	
	//---------------------------------------------------------------
	
	public List<gatech.mmpm.Action> listOfActions() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfActions;

	} // listOfActions

	//---------------------------------------------------------------

	public boolean isActive() {

		return false;

	} // isActive

	//---------------------------------------------------------------
	//                       Getter & setter
	//---------------------------------------------------------------


	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        max_hitpoints feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getMax_hitpoints() {

		return _max_hitpoints;

	} // getMax_hitpoints

	public void setMax_hitpoints(int rhs) {

		_max_hitpoints = rhs;

	} // setMax_hitpoints

	public void setMax_hitpoints(String rhs) {

		_max_hitpoints = Integer.parseInt(rhs);

	} // setMax_hitpoints(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        max_energy feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getMax_energy() {

		return _max_energy;

	} // getMax_energy

	public void setMax_energy(int rhs) {

		_max_energy = rhs;

	} // setMax_energy

	public void setMax_energy(String rhs) {

		_max_energy = Integer.parseInt(rhs);

	} // setMax_energy(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        current_hitpoints feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getCurrent_hitpoints() {

		return _current_hitpoints;

	} // getCurrent_hitpoints

	public void setCurrent_hitpoints(int rhs) {

		_current_hitpoints = rhs;

	} // setCurrent_hitpoints

	public void setCurrent_hitpoints(String rhs) {

		_current_hitpoints = Integer.parseInt(rhs);

	} // setCurrent_hitpoints(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        current_energy feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getCurrent_energy() {

		return _current_energy;

	} // getCurrent_energy

	public void setCurrent_energy(int rhs) {

		_current_energy = rhs;

	} // setCurrent_energy

	public void setCurrent_energy(String rhs) {

		_current_energy = Integer.parseInt(rhs);

	} // setCurrent_energy(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        cost_minerals feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getCost_minerals() {

		return _cost_minerals;

	} // getCost_minerals

	public void setCost_minerals(int rhs) {

		_cost_minerals = rhs;

	} // setCost_minerals

	public void setCost_minerals(String rhs) {

		_cost_minerals = Integer.parseInt(rhs);

	} // setCost_minerals(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        cost_gas feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getCost_gas() {

		return _cost_gas;

	} // getCost_gas

	public void setCost_gas(int rhs) {

		_cost_gas = rhs;

	} // setCost_gas

	public void setCost_gas(String rhs) {

		_cost_gas = Integer.parseInt(rhs);

	} // setCost_gas(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        cost_supply feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getCost_supply() {

		return _cost_supply;

	} // getCost_supply

	public void setCost_supply(int rhs) {

		_cost_supply = rhs;

	} // setCost_supply

	public void setCost_supply(String rhs) {

		_cost_supply = Integer.parseInt(rhs);

	} // setCost_supply(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        attack feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getAttack() {

		return _attack;

	} // getAttack

	public void setAttack(int rhs) {

		_attack = rhs;

	} // setAttack

	public void setAttack(String rhs) {

		_attack = Integer.parseInt(rhs);

	} // setAttack(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        armor feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getArmor() {

		return _armor;

	} // getArmor

	public void setArmor(int rhs) {

		_armor = rhs;

	} // setArmor

	public void setArmor(String rhs) {

		_armor = Integer.parseInt(rhs);

	} // setArmor(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        build_time feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getBuild_time() {

		return _build_time;

	} // getBuild_time

	public void setBuild_time(int rhs) {

		_build_time = rhs;

	} // setBuild_time

	public void setBuild_time(String rhs) {

		_build_time = Integer.parseInt(rhs);

	} // setBuild_time(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        idle feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getIdle() {

		return _idle;

	} // getIdle

	public void setIdle(int rhs) {

		_idle = rhs;

	} // setIdle

	public void setIdle(String rhs) {

		_idle = Integer.parseInt(rhs);

	} // setIdle(String)


	//---------------------------------------------------------------
	//                 Generic getter and setter
	//---------------------------------------------------------------

	public Object featureValue(String feature) {

		if (feature.compareTo("max_hitpoints") == 0)
			return getMax_hitpoints();
		else 
		if (feature.compareTo("max_energy") == 0)
			return getMax_energy();
		else 
		if (feature.compareTo("current_hitpoints") == 0)
			return getCurrent_hitpoints();
		else 
		if (feature.compareTo("current_energy") == 0)
			return getCurrent_energy();
		else 
		if (feature.compareTo("cost_minerals") == 0)
			return getCost_minerals();
		else 
		if (feature.compareTo("cost_gas") == 0)
			return getCost_gas();
		else 
		if (feature.compareTo("cost_supply") == 0)
			return getCost_supply();
		else 
		if (feature.compareTo("attack") == 0)
			return getAttack();
		else 
		if (feature.compareTo("armor") == 0)
			return getArmor();
		else 
		if (feature.compareTo("build_time") == 0)
			return getBuild_time();
		else 
		if (feature.compareTo("idle") == 0)
			return getIdle();
		else 
			return super.featureValue(feature);
	
	} // featureValue

	//---------------------------------------------------------------

	public void setFeatureValue(String feature, String value) {

		if (feature.compareTo("max_hitpoints") == 0)
			setMax_hitpoints(value);
		else 
		if (feature.compareTo("max_energy") == 0)
			setMax_energy(value);
		else 
		if (feature.compareTo("current_hitpoints") == 0)
			setCurrent_hitpoints(value);
		else 
		if (feature.compareTo("current_energy") == 0)
			setCurrent_energy(value);
		else 
		if (feature.compareTo("cost_minerals") == 0)
			setCost_minerals(value);
		else 
		if (feature.compareTo("cost_gas") == 0)
			setCost_gas(value);
		else 
		if (feature.compareTo("cost_supply") == 0)
			setCost_supply(value);
		else 
		if (feature.compareTo("attack") == 0)
			setAttack(value);
		else 
		if (feature.compareTo("armor") == 0)
			setArmor(value);
		else 
		if (feature.compareTo("build_time") == 0)
			setBuild_time(value);
		else 
		if (feature.compareTo("idle") == 0)
			setIdle(value);
		else 
			super.setFeatureValue(feature, value);
	
	} // setFeatureValue

	//---------------------------------------------------------------
	//                       Static methods
	//---------------------------------------------------------------
	
	public static char shortName() {

		return '\0';

	} // shortName

	//---------------------------------------------------------------

	public static List<String> staticListOfFeatures() {

		return _listOfFeatures;

	}

	//---------------------------------------------------------------

	public static List<gatech.mmpm.Action> staticListOfActions() {

		return _listOfActions;

	}

	//---------------------------------------------------------------
	//                       Protected fields
	//---------------------------------------------------------------
	
	protected int _max_hitpoints;

	protected int _max_energy;

	protected int _current_hitpoints;

	protected int _current_energy;

	protected int _cost_minerals;

	protected int _cost_gas;

	protected int _cost_supply;

	protected int _attack;

	protected int _armor;

	protected int _build_time;

	protected int _idle;



	static java.util.List<String> _listOfFeatures;

	static java.util.List<Action> _listOfActions;

	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add features to _listOfFeatures.
		_listOfFeatures = new java.util.LinkedList<String>(gatech.mmpm.PhysicalEntity.staticListOfFeatures());
		_listOfFeatures.add("max_hitpoints");
		_listOfFeatures.add("max_energy");
		_listOfFeatures.add("current_hitpoints");
		_listOfFeatures.add("current_energy");
		_listOfFeatures.add("cost_minerals");
		_listOfFeatures.add("cost_gas");
		_listOfFeatures.add("cost_supply");
		_listOfFeatures.add("attack");
		_listOfFeatures.add("armor");
		_listOfFeatures.add("build_time");
		_listOfFeatures.add("idle");

		// Add valid actions to _listOfActions.
		_listOfActions = new java.util.LinkedList<Action>(gatech.mmpm.PhysicalEntity.staticListOfActions());

	} // static initializer

} // class Unit

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

