/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.sensors;

import gatech.mmpm.Context;
import gatech.mmpm.GameState;
import gatech.mmpm.sensor.Sensor;
import gatech.mmpm.ActionParameterType;
import gatech.mmpm.util.Pair;




/**
 * Class that represents a particular sensor type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Sensor for more information.
 */
public class Buildable extends Sensor {

	public Buildable() {
	} // Constructor

	//---------------------------------------------------------------

	public Buildable(Buildable rhs) {

		super(rhs);

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		Buildable e = new Buildable(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	/**
	 * Return the type of the sensor.
	 * 
	 * Keep in mind that this is <em>not</em> the real Java type,
	 * but the MMPM type. See the 
	 * gatech.mmpm.ActionParameterType.getJavaType() method
	 * for more information.
	 * 
	 * @return Type of the sensor. 
	 */
	public ActionParameterType getType() {
	
		return ActionParameterType.BOOLEAN;

	} // getType

	//---------------------------------------------------------------
	
	public Object evaluate(int cycle, GameState gs, String player, Context parameters) {

		float[] target = (float[]) parameters.get("target");

			if (getTypeParam(parameters,"type")==eisbot.proxy.starmok.entities.Terran_Refinery.class || getTypeParam(parameters,"type")==eisbot.proxy.starmok.entities.Zerg_Extractor.class ||  getTypeParam(parameters,"type")==eisbot.proxy.starmok.entities.Protoss_Assimilator.class) {
				gatech.mmpm.PhysicalEntity pe = gs.getEntityAt(new float[]{target[0]+2*gs.getMap().getCellSizeInDimension(0),target[1]+gs.getMap().getCellSizeInDimension(1),0});
				if (pe!=null && pe instanceof eisbot.proxy.starmok.entities.Resource_Vespene_Geyser &&
					pe.getx()==target[0]+2.0*gs.getMap().getCellSizeInDimension(0) && pe.gety()==target[1]+1.0*gs.getMap().getCellSizeInDimension(0)) return 1.0f;
				return 0.0f;
			} else {
				int sizex = 1;
				int sizey = 1;
				eisbot.proxy.starmok.entities.Unit type = null;
				try {
					type = ((eisbot.proxy.starmok.entities.Unit)getTypeParam(parameters,"type").getConstructor(String.class, String.class).newInstance("",""));
				} catch (IllegalArgumentException e1) {
					e1.printStackTrace();
				} catch (SecurityException e1) {
					e1.printStackTrace();
				} catch (InstantiationException e1) {
					e1.printStackTrace();
				} catch (IllegalAccessException e1) {
					e1.printStackTrace();
				} catch (java.lang.reflect.InvocationTargetException e1) {
					e1.printStackTrace();
				} catch (NoSuchMethodException e1) {
					e1.printStackTrace();
				}
				try {
					sizex = (int) type.getwidth()*4;
					sizey = (int) type.getlength()*4;
				} catch (NullPointerException e1) {
					e1.printStackTrace();
				}
				/*float x, y;
				for(gatech.mmpm.Entity e : gs.getAllEntities()) {
					if(e instanceof gatech.mmpm.PhysicalEntity) {
						x = ((gatech.mmpm.PhysicalEntity) e).getx();
						y = ((gatech.mmpm.PhysicalEntity) e).gety();
						if(x >= target[0] && x <= target[0] + sizex && 
								y >= target[1] && y <= target[1] + sizey) return 0.0f;
					}
				}*/
				gatech.mmpm.TwoDMap map = (gatech.mmpm.TwoDMap) gs.getMap();
				float coords[] = { 0, 0, 0 };
				for (int i = 0; i < sizex; i++) {
					for (int j = 0; j < sizey; j++) {
						coords[0] = target[0] + i;
						coords[1] = target[1] + j;
						if (coords[0] < 0 || coords[1] < 0 || coords[0] >= (int) map.getSizeInDimension(0)
								|| coords[1] >= (int) map.getSizeInDimension(1)) {
							return 0.0f;
						}
						gatech.mmpm.PhysicalEntity e = gs.getEntityAt(coords);
						if (e == null) {
							return 0.0f; // null means "unexplored", and thus, not buildable
						}
						if (e != null && !(e instanceof eisbot.proxy.starmok.entities.BuildableSpace) && !(e instanceof eisbot.proxy.starmok.entities.OpenSpace)) {
							return 0.0f;
						}
					}
				}
				return 1.0f;	      
			}
	
	} // evaluate
	
	//---------------------------------------------------------------
	
	/**
	 * Protected method called from equivalents to compare
	 * two sensors. Subclasses must override this method to
	 * decide if a sensor of the current class is equivalent
	 * to the current sensor.
	 * 
	 * @param s Sensor to compare the current one with.
	 * It will always be an instance of the current class.
	 * @return True if both sensors are equivalents.
	 * 
	 * @note This method should never be externally called.
	 * Use equivalents() instead.
	 */
	protected boolean internalEquivalents(Sensor s) {

		// Auto-generated sensors of the same class are
		// always equivalent in between.
		return true;

	} // internalEquivalents

	//---------------------------------------------------------------
	
	/**
	 * Public method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public java.util.List<Pair<String,ActionParameterType>> getNeededParameters() {

		return _listOfNeededParameters;
	
	} // getNeededParameters

	//---------------------------------------------------------------
	
	/**
	 * Public static method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public static java.util.List<Pair<String,ActionParameterType>> getStaticNeededParameters() {

		return _listOfNeededParameters;
	
	} // getStaticNeededParameters
	
	//---------------------------------------------------------------
	//                       Static fields
	//---------------------------------------------------------------
	
	static java.util.List<Pair<String,ActionParameterType>> _listOfNeededParameters;
	
	
	
	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add parameters to _listOfNeededParameters.
		_listOfNeededParameters = new java.util.LinkedList<Pair<String,ActionParameterType>>(gatech.mmpm.sensor.Sensor.getStaticNeededParameters());
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("target", ActionParameterType.COORDINATE));
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("type", ActionParameterType.ENTITY_TYPE));
		

	} // static initializer

} // class Buildable

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

