/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.sensors;

import gatech.mmpm.Context;
import gatech.mmpm.GameState;
import gatech.mmpm.sensor.Sensor;
import gatech.mmpm.ActionParameterType;
import gatech.mmpm.util.Pair;




/**
 * Class that represents a particular sensor type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Sensor for more information.
 */
public class EntitiesNeededToBuildType extends Sensor {

	public EntitiesNeededToBuildType() {
	} // Constructor

	//---------------------------------------------------------------

	public EntitiesNeededToBuildType(EntitiesNeededToBuildType rhs) {

		super(rhs);

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		EntitiesNeededToBuildType e = new EntitiesNeededToBuildType(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	/**
	 * Return the type of the sensor.
	 * 
	 * Keep in mind that this is <em>not</em> the real Java type,
	 * but the MMPM type. See the 
	 * gatech.mmpm.ActionParameterType.getJavaType() method
	 * for more information.
	 * 
	 * @return Type of the sensor. 
	 */
	public ActionParameterType getType() {
	
		return ActionParameterType.BOOLEAN;

	} // getType

	//---------------------------------------------------------------
	
	public Object evaluate(int cycle, GameState gs, String player, Context parameters) {

		String type = ((Class) parameters.get("type")).getName();
			gatech.mmpm.sensor.builtin.EntityTypeExists realSensor = new gatech.mmpm.sensor.builtin.EntityTypeExists();
			Context params = new Context();
			params.put("owner", player);
			Context params2 = params.clone(params);
			
			switch(eisbot.proxy.types.UnitType.UnitTypes.valueOf(type)) {
				case Terran_Barracks:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Bunker:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Starport:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Factory.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Factory:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Science_Facility:
					Context params3 = params.clone(params);
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					params3.put("type", eisbot.proxy.starmok.entities.Terran_Starport.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params3) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Academy:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Covert_Ops:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Science_Facility.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Missile_Turret:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Engineering_Bay.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Engineering_Bay:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Machine_Shop:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Factory.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Control_Tower:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Starport.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Physics_Lab:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Command_Center.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Science_Facility.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Armory:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Factory.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Gateway:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Nexus.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Cybernetics_Core:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Gateway.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Stargate:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Cybernetics_Core.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Citadel_of_Adun:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Cybernetics_Core.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Templar_Archives:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Citadel_of_Adun.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Robotics_Facility:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Cybernetics_Core.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Robotics_Support_Bay:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Robotics_Facility.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Observatory:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Robotics_Facility.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Forge:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Photon_Cannon:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Forge.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Shield_Battery:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Gateway.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Pylon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Zerg_Lair:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hatchery.class);
					params2.put("type", eisbot.proxy.starmok.entities.Zerg_Spawning_Pool.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Zerg_Hive:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Lair.class);
					params2.put("type", eisbot.proxy.starmok.entities.Zerg_Queens_Nest.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Zerg_Queens_Nest:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Lair.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Zerg_Hydralisk_Den:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hatchery.class);
					params2.put("type", eisbot.proxy.starmok.entities.Zerg_Spawning_Pool.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Zerg_Spore_Colony:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hatchery.class);
					params2.put("type", eisbot.proxy.starmok.entities.Zerg_Evolution_Chamber.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Zerg_Defiler_Mound:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hive.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Zerg_Spire:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Lair.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Zerg_Greater_Spire:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Spire.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Zerg_Sunken_Colony:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hatchery.class);
					params2.put("type", eisbot.proxy.starmok.entities.Zerg_Spawning_Pool.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Zerg_Ultralisk_Cavern:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hive.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Zerg_Nydus_Canal:
					params.put("type", eisbot.proxy.starmok.entities.Zerg_Hive.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
			}
			return 1.0f;
	
	} // evaluate
	
	//---------------------------------------------------------------
	
	/**
	 * Protected method called from equivalents to compare
	 * two sensors. Subclasses must override this method to
	 * decide if a sensor of the current class is equivalent
	 * to the current sensor.
	 * 
	 * @param s Sensor to compare the current one with.
	 * It will always be an instance of the current class.
	 * @return True if both sensors are equivalents.
	 * 
	 * @note This method should never be externally called.
	 * Use equivalents() instead.
	 */
	protected boolean internalEquivalents(Sensor s) {

		// Auto-generated sensors of the same class are
		// always equivalent in between.
		return true;

	} // internalEquivalents

	//---------------------------------------------------------------
	
	/**
	 * Public method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public java.util.List<Pair<String,ActionParameterType>> getNeededParameters() {

		return _listOfNeededParameters;
	
	} // getNeededParameters

	//---------------------------------------------------------------
	
	/**
	 * Public static method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public static java.util.List<Pair<String,ActionParameterType>> getStaticNeededParameters() {

		return _listOfNeededParameters;
	
	} // getStaticNeededParameters
	
	//---------------------------------------------------------------
	//                       Static fields
	//---------------------------------------------------------------
	
	static java.util.List<Pair<String,ActionParameterType>> _listOfNeededParameters;
	
	
	
	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add parameters to _listOfNeededParameters.
		_listOfNeededParameters = new java.util.LinkedList<Pair<String,ActionParameterType>>(gatech.mmpm.sensor.Sensor.getStaticNeededParameters());
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("type", ActionParameterType.ENTITY_TYPE));
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("owner", ActionParameterType.PLAYER));
		

	} // static initializer

} // class EntitiesNeededToBuildType

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

