/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.sensors;

import gatech.mmpm.Context;
import gatech.mmpm.GameState;
import gatech.mmpm.sensor.Sensor;
import gatech.mmpm.ActionParameterType;
import gatech.mmpm.util.Pair;




/**
 * Class that represents a particular sensor type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Sensor for more information.
 */
public class EntitiesNeededToTrainType extends Sensor {

	public EntitiesNeededToTrainType() {
	} // Constructor

	//---------------------------------------------------------------

	public EntitiesNeededToTrainType(EntitiesNeededToTrainType rhs) {

		super(rhs);

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		EntitiesNeededToTrainType e = new EntitiesNeededToTrainType(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	/**
	 * Return the type of the sensor.
	 * 
	 * Keep in mind that this is <em>not</em> the real Java type,
	 * but the MMPM type. See the 
	 * gatech.mmpm.ActionParameterType.getJavaType() method
	 * for more information.
	 * 
	 * @return Type of the sensor. 
	 */
	public ActionParameterType getType() {
	
		return ActionParameterType.BOOLEAN;

	} // getType

	//---------------------------------------------------------------
	
	public Object evaluate(int cycle, GameState gs, String player, Context parameters) {

		String type = ((Class) parameters.get("type")).getName();
			Context params = new Context();
			gatech.mmpm.sensor.builtin.EntityTypeExists realSensor = new gatech.mmpm.sensor.builtin.EntityTypeExists();
			params.put("owner", player);
			Context params2 = params.clone(params);
			Context params3 = params.clone(params);
			Context params4 = params.clone(params);
			
	      	switch(eisbot.proxy.types.UnitType.UnitTypes.valueOf(type)) {
				case Terran_Marine:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Firebat:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Academy.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Medic:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Academy.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Ghost:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Academy.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Barracks.class);
					params3.put("type", eisbot.proxy.starmok.entities.Terran_Science_Facility.class);
					params4.put("type", eisbot.proxy.starmok.entities.Terran_Covert_Ops.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params3) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params4) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Vulture:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Factory.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Siege_Tank_Tank_Mode:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Factory.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Machine_Shop.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Goliath:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Factory.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Machine_Shop.class);
					params3.put("type", eisbot.proxy.starmok.entities.Terran_Armory.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params3) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Wraith:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Starport.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Dropship:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Starport.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Terran_Valkyrie:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Starport.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Armory.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Terran_Battlecruiser:
					params.put("type", eisbot.proxy.starmok.entities.Terran_Starport.class);
					params2.put("type", eisbot.proxy.starmok.entities.Terran_Science_Facility.class);
					params3.put("type", eisbot.proxy.starmok.entities.Terran_Physics_Lab.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params3) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Probe:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Nexus.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Zealot:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Gateway.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Dragoon:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Gateway.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Cybernetics_Core.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_High_Templar:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Gateway.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Templar_Archives.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Dark_Templar:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Gateway.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Templar_Archives.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Reaver:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Robotics_Facility.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Robotics_Support_Bay.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Shuttle:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Robotics_Facility.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Observer:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Robotics_Facility.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Observatory.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Scout:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Stargate.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Corsair:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Stargate.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
				case Protoss_Carrier:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Stargate.class);
					params2.put("type", eisbot.proxy.starmok.entities.Protoss_Fleet_Beacon.class);
					return ((realSensor.evaluate(cycle, gs, player, params) == (Object)1.0f && 
						realSensor.evaluate(cycle, gs, player, params2) == (Object)1.0f) ? 1.0f : 0.0f);
					
				case Protoss_Arbiter:
					params.put("type", eisbot.proxy.starmok.entities.Protoss_Stargate.class);
					return realSensor.evaluate(cycle, gs, player, params);
					
			}
			return 1.0f;
	
	} // evaluate
	
	//---------------------------------------------------------------
	
	/**
	 * Protected method called from equivalents to compare
	 * two sensors. Subclasses must override this method to
	 * decide if a sensor of the current class is equivalent
	 * to the current sensor.
	 * 
	 * @param s Sensor to compare the current one with.
	 * It will always be an instance of the current class.
	 * @return True if both sensors are equivalents.
	 * 
	 * @note This method should never be externally called.
	 * Use equivalents() instead.
	 */
	protected boolean internalEquivalents(Sensor s) {

		// Auto-generated sensors of the same class are
		// always equivalent in between.
		return true;

	} // internalEquivalents

	//---------------------------------------------------------------
	
	/**
	 * Public method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public java.util.List<Pair<String,ActionParameterType>> getNeededParameters() {

		return _listOfNeededParameters;
	
	} // getNeededParameters

	//---------------------------------------------------------------
	
	/**
	 * Public static method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public static java.util.List<Pair<String,ActionParameterType>> getStaticNeededParameters() {

		return _listOfNeededParameters;
	
	} // getStaticNeededParameters
	
	//---------------------------------------------------------------
	//                       Static fields
	//---------------------------------------------------------------
	
	static java.util.List<Pair<String,ActionParameterType>> _listOfNeededParameters;
	
	
	
	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add parameters to _listOfNeededParameters.
		_listOfNeededParameters = new java.util.LinkedList<Pair<String,ActionParameterType>>(gatech.mmpm.sensor.Sensor.getStaticNeededParameters());
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("type", ActionParameterType.ENTITY_TYPE));
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("owner", ActionParameterType.PLAYER));
		

	} // static initializer

} // class EntitiesNeededToTrainType

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

