/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package eisbot.proxy.starmok.sensors;

import gatech.mmpm.Context;
import gatech.mmpm.GameState;
import gatech.mmpm.sensor.Sensor;
import gatech.mmpm.ActionParameterType;
import gatech.mmpm.util.Pair;




/**
 * Class that represents a particular sensor type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Sensor for more information.
 */
public class HasPath extends Sensor {

	public HasPath() {
	} // Constructor

	//---------------------------------------------------------------

	public HasPath(HasPath rhs) {

		super(rhs);

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		HasPath e = new HasPath(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	/**
	 * Return the type of the sensor.
	 * 
	 * Keep in mind that this is <em>not</em> the real Java type,
	 * but the MMPM type. See the 
	 * gatech.mmpm.ActionParameterType.getJavaType() method
	 * for more information.
	 * 
	 * @return Type of the sensor. 
	 */
	public ActionParameterType getType() {
	
		return ActionParameterType.BOOLEAN;

	} // getType

	//---------------------------------------------------------------
	
	public Object evaluate(int cycle, GameState gs, String player, Context parameters) {

		gatech.mmpm.PhysicalEntity unit = (gatech.mmpm.PhysicalEntity) parameters.get("entity");
			float[] target = (float[]) parameters.get("coor");
			int[] mapRegions = null;
			gatech.mmpm.TwoDMap map = (gatech.mmpm.TwoDMap) gs.getMap();
			
			if (gs.getEntityAt(target) == null ||
					unit instanceof eisbot.proxy.starmok.entities.Protoss_Air || 
					unit instanceof eisbot.proxy.starmok.entities.Terran_Air ||
					unit instanceof eisbot.proxy.starmok.entities.Zerg_Air) return 1.0f;
			
			if (mapRegions == null) {
				int region = 1;
				mapRegions = new int[map.size()];
				for (int i = 0; i < map.size(); i++) {
					mapRegions[i] = 0;
				}

				for (int i = 0; i < map.size(); i++) {
					java.util.List<Integer> open = new java.util.LinkedList<Integer>();
					java.util.HashSet<Integer> visited = new java.util.HashSet<Integer>();

					if (mapRegions[i] == 0) {
						if (map.get(i) == null || map.get(i) instanceof eisbot.proxy.starmok.entities.WalkableSpace || map.get(i) instanceof eisbot.proxy.starmok.entities.OpenSpace) {
							open.add(i);
							visited.add(open.get(0));
							while (!open.isEmpty()) {
								int current = open.remove(0);
								if (map.get(current) == null || map.get(current) instanceof eisbot.proxy.starmok.entities.WalkableSpace || map.get(i) instanceof eisbot.proxy.starmok.entities.OpenSpace) {
									mapRegions[current] = region;
									int coords[] = map.toCellCoords(current);
									if (coords[0] > 0) {
										int n = map.toCell(new int[]{coords[0] - 1, coords[1], 0});
										if (!visited.contains(n)) {
											open.add(n);
											visited.add(n);
										}
									}
									if (coords[1] > 0) {
										int n = map.toCell(new int[]{coords[0], coords[1] - 1, 0});
										if (!visited.contains(n)) {
											open.add(n);
											visited.add(n);
										}
									}
									if (coords[0] < map.getSizeInDimension(0) - 1) {
										int n = map.toCell(new int[]{coords[0] + 1, coords[1], 0});
										if (!visited.contains(n)) {
											open.add(n);
											visited.add(n);
										}
									}
									if (coords[1] < map.getSizeInDimension(1) - 1) {
										int n = map.toCell(new int[]{coords[0], coords[1] + 1, 0});
										if (!visited.contains(n)) {
											open.add(n);
											visited.add(n);
										}
									}
								}
							}
						}
					}
				}
			}
			
			if  (mapRegions[map.toCell(target)]==mapRegions[map.toCell(unit.get_Coords())]) return 1.0f;
			return 0.0f;
	
	} // evaluate
	
	//---------------------------------------------------------------
	
	/**
	 * Protected method called from equivalents to compare
	 * two sensors. Subclasses must override this method to
	 * decide if a sensor of the current class is equivalent
	 * to the current sensor.
	 * 
	 * @param s Sensor to compare the current one with.
	 * It will always be an instance of the current class.
	 * @return True if both sensors are equivalents.
	 * 
	 * @note This method should never be externally called.
	 * Use equivalents() instead.
	 */
	protected boolean internalEquivalents(Sensor s) {

		// Auto-generated sensors of the same class are
		// always equivalent in between.
		return true;

	} // internalEquivalents

	//---------------------------------------------------------------
	
	/**
	 * Public method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public java.util.List<Pair<String,ActionParameterType>> getNeededParameters() {

		return _listOfNeededParameters;
	
	} // getNeededParameters

	//---------------------------------------------------------------
	
	/**
	 * Public static method that provides the parameters that 
	 * this sensor uses to be evaluated. This method provides
	 * all the parameters that can be used in the evaluation, 
	 * nevertheless some sensor can be evaluated with only 
	 * some of them.
	 * 
	 * @return The list of needed parameters this sensor needs
	 * to be evaluated.
	 */
	public static java.util.List<Pair<String,ActionParameterType>> getStaticNeededParameters() {

		return _listOfNeededParameters;
	
	} // getStaticNeededParameters
	
	//---------------------------------------------------------------
	//                       Static fields
	//---------------------------------------------------------------
	
	static java.util.List<Pair<String,ActionParameterType>> _listOfNeededParameters;
	
	
	
	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add parameters to _listOfNeededParameters.
		_listOfNeededParameters = new java.util.LinkedList<Pair<String,ActionParameterType>>(gatech.mmpm.sensor.Sensor.getStaticNeededParameters());
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("entity", ActionParameterType.ENTITY_ID));
		_listOfNeededParameters.add(new Pair<String,ActionParameterType>("coor", ActionParameterType.COORDINATE));
		

	} // static initializer

} // class HasPath

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

