/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/


package bc.mmpm.entities;

import gatech.mmpm.Action;


import java.util.List;

/**
 * Class that represents a particular entity type
 * of the game. It contains machine generate code.
 * Go to gatech.mmpm.Entity for more information.
 */
public class BCOTankGenerator extends gatech.mmpm.PhysicalEntity {

	public BCOTankGenerator(String entityID, String owner) {
	
		super(entityID, owner);
		
	} // Constructor

	//---------------------------------------------------------------

	public BCOTankGenerator(BCOTankGenerator rhs) {

		super(rhs);
		_time_for_next = rhs._time_for_next;
		_remaining_tanks = rhs._remaining_tanks;
		_interval = rhs._interval;
		_tank_type = rhs._tank_type;

	} // Copy constructor 
	
	//---------------------------------------------------------------

	public Object clone() {

		BCOTankGenerator e = new BCOTankGenerator(this);
		return e;

	} // clone

	//---------------------------------------------------------------

	public char instanceShortName() {
	
		return '\0';
	
	} // instanceShortName

	//---------------------------------------------------------------
	
	public List<String> listOfFeatures() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfFeatures;

	} // listOfFeatures
	
	//---------------------------------------------------------------
	
	public List<gatech.mmpm.Action> listOfActions() {
	
		// Overwritten in each entity class to return the
		// class static attribute. 
		return _listOfActions;

	} // listOfActions

	//---------------------------------------------------------------

	public boolean isActive() {

		return false;

	} // isActive

	//---------------------------------------------------------------
	//                       Getter & setter
	//---------------------------------------------------------------


	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        time_for_next feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getTime_for_next() {

		return _time_for_next;

	} // getTime_for_next

	public void setTime_for_next(int rhs) {

		_time_for_next = rhs;

	} // setTime_for_next

	public void setTime_for_next(String rhs) {

		_time_for_next = Integer.parseInt(rhs);

	} // setTime_for_next(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        remaining_tanks feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getRemaining_tanks() {

		return _remaining_tanks;

	} // getRemaining_tanks

	public void setRemaining_tanks(int rhs) {

		_remaining_tanks = rhs;

	} // setRemaining_tanks

	public void setRemaining_tanks(String rhs) {

		_remaining_tanks = Integer.parseInt(rhs);

	} // setRemaining_tanks(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        interval feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public int getInterval() {

		return _interval;

	} // getInterval

	public void setInterval(int rhs) {

		_interval = rhs;

	} // setInterval

	public void setInterval(String rhs) {

		_interval = Integer.parseInt(rhs);

	} // setInterval(String)

	//- - - - - - - - - - - - - - - - - - - - - - - -
	//        tank_type feature 
	//- - - - - - - - - - - - - - - - - - - - - - - - 

	public String getTank_type() {

		return _tank_type;

	} // getTank_type

	public void setTank_type(String rhs) {

		_tank_type = rhs;

	} // setTank_type


	//---------------------------------------------------------------
	//                 Generic getter and setter
	//---------------------------------------------------------------

	public Object featureValue(String feature) {

		if (feature.compareTo("time_for_next") == 0)
			return getTime_for_next();
		else 
		if (feature.compareTo("remaining_tanks") == 0)
			return getRemaining_tanks();
		else 
		if (feature.compareTo("interval") == 0)
			return getInterval();
		else 
		if (feature.compareTo("tank_type") == 0)
			return getTank_type();
		else 
			return super.featureValue(feature);
	
	} // featureValue

	//---------------------------------------------------------------

	public void setFeatureValue(String feature, String value) {

		if (feature.compareTo("time_for_next") == 0)
			setTime_for_next(value);
		else 
		if (feature.compareTo("remaining_tanks") == 0)
			setRemaining_tanks(value);
		else 
		if (feature.compareTo("interval") == 0)
			setInterval(value);
		else 
		if (feature.compareTo("tank_type") == 0)
			setTank_type(value);
		else 
			super.setFeatureValue(feature, value);
	
	} // setFeatureValue

	//---------------------------------------------------------------
	//                       Static methods
	//---------------------------------------------------------------
	
	public static char shortName() {

		return '\0';

	} // shortName

	//---------------------------------------------------------------

	public static List<String> staticListOfFeatures() {

		return _listOfFeatures;

	}

	//---------------------------------------------------------------

	public static List<gatech.mmpm.Action> staticListOfActions() {

		return _listOfActions;

	}

	//---------------------------------------------------------------
	//                       Protected fields
	//---------------------------------------------------------------
	
	protected int _time_for_next;

	protected int _remaining_tanks;

	protected int _interval;

	protected String _tank_type;



	static java.util.List<String> _listOfFeatures;

	static java.util.List<Action> _listOfActions;

	//---------------------------------------------------------------
	//                       Static initializers
	//---------------------------------------------------------------

	static {

		// Add features to _listOfFeatures.
		_listOfFeatures = new java.util.LinkedList<String>(gatech.mmpm.PhysicalEntity.staticListOfFeatures());
		_listOfFeatures.add("time_for_next");
		_listOfFeatures.add("remaining_tanks");
		_listOfFeatures.add("interval");
		_listOfFeatures.add("tank_type");

		// Add valid actions to _listOfActions.
		_listOfActions = new java.util.LinkedList<Action>(gatech.mmpm.PhysicalEntity.staticListOfActions());

	} // static initializer

} // class BCOTankGenerator

/*******************************************************************
 *                       MACHINE GENERATED CODE                    *
 *                            DO NOT EDIT                          *
 *        FIX THE SOURCE XML INSTEAD, AND REGENERATE IT AGAIN      *
 *                                                                 *
 *                                                                 *
 * Tool: gatech.mmpm.tools.DomainGenerator                         *
 *                                                                 *
 * Organization: Georgia Institute of Technology                   *
 *               Cognitive Computing Lab (CCL)                     *
 * Authors:      Pedro Pablo Gomez Martin                          *
 *               Marco Antonio Gomez Martin                        *
 * Based on previous work of:                                      *
 *               Jai Rad                                           *
 *               Prafulla Mahindrakar                              *
 *               Santi Ontan                                     *
 *******************************************************************/

